game/urls.py
from django.urls import path
from . import views
app_name = "game"
urlpatterns = [
    path('',views.index, name ='index'),
    path('save_game/',views.save_game,name='save'),
]

profil/urls.py
from django.urls import path

from . import views

app_name = 'profil'
urlpatterns = [
    path('', views.index, name='index'),
]

webChess/urls.py
from django.urls import path, include
from django.contrib import admin
from django.views.generic.base import TemplateView
import django_cas_ng.views
urlpatterns = [
    path('', TemplateView.as_view(template_name='home.html'), name='home'),
    path('admin/', admin.site.urls),
    path('game/',include('game.urls'), name = 'game'),
    path('profil/',include('profil.urls'), name = 'profil'),
    path('accounts/login/', django_cas_ng.views.LoginView.as_view(), name='cas_ng_login'),
    path('accounts/logout/', django_cas_ng.views.LogoutView.as_view(), name='cas_ng_logout'),
    path('accounts/callback/', django_cas_ng.views.CallbackView.as_view(), name='cas_ng_proxy_callback'),
]

game/models.py
from django.db import models
from django.contrib.auth.models import User
from django.db.models.signals import post_save
from django.dispatch import receiver
from decimal import Decimal
from django.utils import timezone
from django.db.models import Q


class Game(models.Model):
    id_game = models.AutoField(primary_key=True, blank=False)
    white_player = models.CharField(max_length=10, default=None)
    black_player = models.CharField(max_length=10, default=None)
    winner = models.CharField(max_length=10, default=None)
    history = models.TextField(blank = True)
    note = models.CharField(max_length=150, blank = True)
    time = models.DateTimeField(default=timezone.now, blank=False)
    present = models.NullBooleanField(default=False) 
    # def __repr__(self):
    # 	return self.id_game

profil/models.py
from django.db import models
from django.contrib.auth.models import User
from django.db.models.signals import post_save
from django.dispatch import receiver
from decimal import Decimal
from django.utils import timezone
from django.db.models import Q

# ajoute admin 
user = User.objects.get(username="nguyetra") 
user.is_staff = True 
user.is_admin = True 
user.is_superuser = True 
user.save() 

user = User.objects.get(username="tranquoc") 
user.is_staff = True 
user.is_admin = True 
user.is_superuser = True 
user.save() 

class Player(models.Model):
    user = models.OneToOneField(User, on_delete= models.CASCADE)
    no_of_wins = models.DecimalField(max_digits=5, decimal_places=0, default=Decimal('0'))
    no_of_games = models.DecimalField(max_digits=5, decimal_places=0, default=Decimal('0'))
    no_of_draws = models.DecimalField(max_digits=5, decimal_places=0, default=Decimal('0'))
    def __str__(self):
    	return self.user.username
    # Mise a jour Player a chaque moment ou un user vient d'etre ajoute 
    @receiver(post_save, sender = User)
    def create_user_profile(sender,instance, created,**kwargs):
        if created:
            Player.objects.create(user = instance)

game/views.py
import json

from django.shortcuts import render
from django.contrib.auth.decorators import login_required
from game.models import Game
from profil.models import Player
from django.http import HttpResponse, HttpResponseRedirect
from django.views.decorators.csrf import csrf_exempt

# Create your views here.
@login_required
def index(request):
    return render(request, 'index.html')


# this view must be csrf exempted to be able to accept XMLHttpRequests
@csrf_exempt
def save_game(request):
    if request.method == 'POST':
        msg_obj = json.loads(request.body.decode('utf-8'))
        print(msg_obj)
        try:
            msg = Game.objects.create(white_player=msg_obj['white_player'], black_player=msg_obj['black_player'], winner = msg_obj['winner'], history = msg_obj['history'], note =msg_obj['note'] )
            msg.save()
            white = Player.objects.get(user__username = msg_obj['white_player'])
            black = Player.objects.get(user__username = msg_obj['black_player'])
            black.no_of_games += 1
            white.no_of_games += 1
            if msg_obj['winner'] == 'draw' :
                white.no_of_draw += 1
                black.no_of_draw += 1
            else :
                if white.user.username == msg_obj['winner'] :
                    white.no_of_wins += 1
                else:
                    black.no_of_wins += 1
            white.save()
            black.save()
        except Exception as ex:
            print("error saving game: %s" % ex)
        return HttpResponse("success")
    else:
        return HttpResponseRedirect('/')

profil/views.py
from django.shortcuts import render
from django.contrib.auth.decorators import login_required
from profil.models import Player
from django.contrib.auth.models import User
import math


# Create your views here.
@login_required
def index(request):
	player = Player.objects.get(user__username = request.user)
	rate_of_win = round(player.no_of_wins / player.no_of_games,2)*100
	return render(request, "profil.html", {"player":player, "rate": rate_of_win})

game/templates/index.html
{% load static %}

<!doctype html>
<html>

<head>
   <meta charset="utf-8"> 
  <meta name="viewport" content="width=device-width" /> 
<!-- Logo fablab --> 
 <link rel="icon" href="http://fablabutc.fr/resources/pics/cropped-logo-32x32.png " sizes="32x32"> 
 <link rel="icon" href="http://fablabutc.fr/resources/pics/cropped-logo-192x192.png " sizes="192x192"> 
<!-- css de boostrap --> 
   <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.1.3/css/bootstrap.min.css" integrity="sha384-MCw98/SFnGE8fJT3GXwEOngsV7Zt27NXFoaoApmYm81iuXoPkFOJwJ8ERdknLPMO" crossorigin="anonymous"> 
   <script src="https://code.jquery.com/jquery-3.3.1.slim.min.js" integrity="sha384-q8i/X+965DzO0rT7abK41JStQIAqVgRVzpbzo5smXKp4YfRvH+8abtTE1Pi6jizo" crossorigin="anonymous"></script> 
    <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.14.3/umd/popper.min.js" integrity="sha384-ZMP7rVo3mIykV+2+9J3UJ46jBk0WLaUAdn689aCwoqbBJiSnjAK/l8WvCWPIPm49" crossorigin="anonymous"></script> 
    <script src="https://stackpath.bootstrapcdn.com/bootstrap/4.1.3/js/bootstrap.min.js" integrity="sha384-ChfqqxuZUCnJSK3+MXmPNIyE6ZbWh2IMqE241rYiqJxyMiZ6OW/JmZQ5stwEULTy" crossorigin="anonymous"></script> 
<!-- css chessboard --> 
  <link rel="stylesheet" href='{% static "css/chessboard-0.3.0.min.css" %}' type="text/css" />
  <link rel="stylesheet" href='{% static "css/main.css" %}' type="text/css" />
  <title>Game - Chess FABLAB</title>
</head>

<body>
   <header style="background-color: #fbefc1"> 
    <table class='borderless table'> 
       <tr> 
        <th> 
          <a class='LogoCentre' href="#"><img src="{% static "img/fablab-logo.png" %}" alt="logoFabLab" style=" max-height: 70%; 
  width: auto; margin-left: 40px;"/></a>   
        </th> 
        <th style="text-align: right;"> 
          <a class='btn btn-warning' href="{% url 'home' %}" role="button" style="margin-right:40px;"> Homepage</a> 
        </th> 
       </tr> 
    </table>    
  </header> 

  <div style="margin-left: 30px; font-family: roboto;"> 
    <p>You:<b> {{user.username}}<input id='username' value='{{user.username}}' type="hidden"></b></p> 
    Your opponent: <b><label id='opponentname'></label></b>
  </div>
  <div id='page-lobby' style="margin-left:10%">
    <div id='userList'></div>
  </div>

  <div class="page-game" id='page-game' style="float: left;margin-left: auto;margin-right:auto;width: 74%;text-align : center">
    <div class='boardGame' id='board'></div>
    <p><button class="btn btn-warning" id='game-quit'>Quit</button></p>
  </div>  

  <script src="https://code.jquery.com/jquery-3.2.1.min.js"></script>
  <script src="http://localhost:4000/socket.io/socket.io.js"></script>
  <!-- libary of chess -->
  <script src='{% static "js/chess.min.js" %}'></script>
  <script src='{% static "js/chessboard-0.3.0.min.js" %}'></script>
  <script src='{% static "js/main.js" %}'></script>

  <div id='page-notification' style="float: right; width: 26%;font-family: roboto;overflow: auto;height: 300px" > 
    Status: <span id="status"></span>
    <table> 
      <thead> 
        <tr> 
          <th>From</th> 
          <th>To</th> 
          <th>Piece</th> 
        </tr> 
      </thead> 
      <tbody id="move-history">
      </tbody>
    </table> 
  </div> 
  <!-- <div style="bottom: 0;background-color: #fbefc1;height: 60px; text-align: center;"> 
    <footer> Project PR00 - The robotic chessboard of FABLAB - A18 
    </footer>   
  </div> --> 
</body>

</html>

templates/base.html
{% load static %}
<!DOCTYPE html>
<html>
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width" />
<!-- Logo fablab -->
 <link rel="icon" href="http://fablabutc.fr/resources/pics/cropped-logo-32x32.png " sizes="32x32">
 <link rel="icon" href="http://fablabutc.fr/resources/pics/cropped-logo-192x192.png " sizes="192x192">

  <link rel="stylesheet" type="text/css" href="{% static 'css/style.css' %}">
<!-- css de boostrap -->
   <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.1.3/css/bootstrap.min.css" integrity="sha384-MCw98/SFnGE8fJT3GXwEOngsV7Zt27NXFoaoApmYm81iuXoPkFOJwJ8ERdknLPMO" crossorigin="anonymous">
   <script src="https://code.jquery.com/jquery-3.3.1.slim.min.js" integrity="sha384-q8i/X+965DzO0rT7abK41JStQIAqVgRVzpbzo5smXKp4YfRvH+8abtTE1Pi6jizo" crossorigin="anonymous"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.14.3/umd/popper.min.js" integrity="sha384-ZMP7rVo3mIykV+2+9J3UJ46jBk0WLaUAdn689aCwoqbBJiSnjAK/l8WvCWPIPm49" crossorigin="anonymous"></script>
    <script src="https://stackpath.bootstrapcdn.com/bootstrap/4.1.3/js/bootstrap.min.js" integrity="sha384-ChfqqxuZUCnJSK3+MXmPNIyE6ZbWh2IMqE241rYiqJxyMiZ6OW/JmZQ5stwEULTy" crossorigin="anonymous"></script>
    <title>Chess FABLAB</title>
    
</head>
<body class="bodystyle">  
  <header> <!-- class of bootstrap-->
   <section class="container zone-logo">
      <a class="LogoCentre" href="#" style="display:block; text-align:center;">
         <img src="{% static "img/fablab-logo.png" %}" alt="logoFabLab" /></a>  
   </section>
  </header>
  <section style="text-align: center;margin: auto;">
    {% block section %}
    {% endblock section %} 
     <main>
      {% block content %}
      {% endblock %}
    </main>
  </section>
</body>
</html>

templates/home.html
{% extends 'base.html' %}

{% block title %}Home{% endblock %}

{% block content %}
{% if user.is_authenticated %}
<!-- Prévoir : ajouter application chess,consulter la profile -->	
  <p><h2>Hi {{ user.username }}! </h2></p>
  <p>
    <a class="btn btn-warning" href="{% url 'game:index' %}" role="button"> Game </a>
    <a class="btn btn-warning" href="{% url 'profil:index' %}" role="button"> Your space </a>
    <a class="btn btn-warning" href="{% url 'cas_ng_logout' %}" role="button"> Logout </a>
  </p>
{% else %}
  <p>You are not logged in</p>
  <a class="btn btn-warning" href="{% url 'cas_ng_login' %}" role="button"> Login </a>
{% endif %}
{% endblock %}

templates/profil.html
{% extends 'base.html' %}

{% block title %}Your Space{% endblock %}
{% block content %}

<p><h2>Your profil</h2></p>

<div class="container" style ="max-width: 60%">
<table class="table table-bordered", style="text-align: left;background-color: #000000c3;line-height: 1">
    <tr>
      <th scope="col">Username</th>
      <th scope="col">{{ user.username }}</th>
    </tr>
    <tr>
      <th scope="col">Email</th>
      <th scope="col">{{ user.username }}@etu.utc.fr</th>
    </tr>
    <tr>
      <th scope="col">Nombre de jeux</th>
      <th scope="col">{{ player.no_of_games }}</th>
    </tr>
    <tr>
      <th scope="col">Nombre de gagnants</th>
      <th scope="col">{{ player.no_of_wins }}</th>
    </tr>
    <tr>
      <th scope="col">Nombre de tirages</th>
      <th scope="col">{{ player.no_of_draws }}</th>
    </tr>
    <tr>
      <th scope="col">Rate of wins</th>
      <th scope="col">{{ rate }}%</th>
    </tr>    
</table>
</div>
 <p>    <a class="btn btn-warning" href="{% url 'home' %}" role="button"> Homepage </a>
{% endblock %}